From 67557c4a640c3b9e49c81ad34a52fc2514e2e6be Mon Sep 17 00:00:00 2001
From: Kamil Páral <kparal@redhat.com>
Date: May 15 2018 14:03:19 +0000
Subject: [PATCH 4/7] restructure per review comments


---

diff --git a/libtaskotron/executor.py b/libtaskotron/executor.py
index 16dbf4c..46b1a7f 100644
--- a/libtaskotron/executor.py
+++ b/libtaskotron/executor.py
@@ -12,7 +12,6 @@ import yaml
 import fnmatch
 import signal
 import json
-import copy
 
 from libtaskotron import config
 from libtaskotron import image_utils
@@ -41,6 +40,27 @@ class Executor(object):
     :ivar bool run_remotely: whether the task is run on a remote machine
     '''
 
+    #: vars retrieved from tests.yml
+    ACCEPTED_VARS = [
+        # if you adjust this, also adjust writingtasks.rst
+        'taskotron_generic_task',
+        'taskotron_keepalive_minutes',
+        'taskotron_match_host_arch',
+        'taskotron_match_host_distro',
+        'taskotron_match_host_release',
+    ]
+
+    #: list of all vars to be exposed in the task playbook
+    FORWARDED_VARS = [
+        # if you adjust this, also adjust writingtasks.rst
+        'artifacts',
+        'taskotron_arch',
+        'taskotron_item_type',
+        'taskotron_item',
+        'taskotron_supported_arches',
+        'taskotron_supported_binary_arches',
+    ]
+
     def __init__(self, arg_data):
         self.arg_data = arg_data
         self.task_vm = None
@@ -142,41 +162,125 @@ class Executor(object):
             raise exc.TaskotronPlaybookError(e)
 
     def _create_playbook_vars(self, test_playbook):
-        vars_ = copy.deepcopy(_PLAYBOOK_VARS_TEMPLATE)
+        '''Create and return dictionary containing all variables to be used
+        with our ansible playbook. The dictionary contains these keys:
+
+        artifacts_root
+          path to the root artifacts directory (on overlord and minion)
+
+        artifacts
+          path to the playbook-specific artifacts directory (on overlord and
+          minion)
+
+        client_taskdir
+          path to directory with test suite (on minion)
+
+        exec_tasks
+          path to taskotron tasks playbook (generic or STI)
+
+        heartbeat_file
+          heartbeat will appear in this file
+
+        heartbeat_interval
+          add line to heartbeat_file every x seconds (2 minutes)
+
+        local
+          running on local machine (overlord), no remote connection
+
+        minion_repos
+          a list of repos (strings) to install on the minion
+
+        sti_inventory
+          path to inventory file to be used with STI tests (local inside
+          client_taskdir or global)
+
+        taskdir
+          path to directory with test suite (on overlord)
+
+        taskotron_arch
+          architecture of taskotron_item to be tested
+
+        taskotron_generic_task
+          whether to run a generic or STI task
+
+        taskotron_item_type
+          item under test
+
+        taskotron_item
+          item type under test
+
+        taskotron_keepalive_minutes
+          how long should heartbeat process run (0 to disable)
+
+        taskotron_match_host_arch
+          whether VM guest arch has to match taskotron_arch
+
+        taskotron_match_host_distro
+          whether VM guest distro has to match taskotron_item
+
+        taskotron_match_host_release
+          whether VM guest release has to match taskotron_item
+
+        taskotron_supported_arches
+          list of base architectures supported by Taskotron (e.g. 'armhfp')
+
+        taskotron_supported_binary_arches
+          list of base+binary architectures supported by Taskotron (e.g. 'armhfp,
+          armv7hl')
+
+        test_playbook
+          path to playbook to execute inside client_taskdir (usually tests.yml)
+
+        varsfile
+          name of the ansible vars file inside artifacts/taskotron/ to forward to
+          task
+        '''
+
+        vars_ = {}
         cfg = config.get_config()
 
-        # load all provided taskotron_* vars first, so that they don't override
-        # out logic later on
+        # default values
+        vars_['taskotron_generic_task'] = False
+        vars_['heartbeat_interval'] = 120
+        vars_['taskotron_keepalive_minutes'] = 0
+        vars_['taskotron_match_host_arch'] = False
+        vars_['taskotron_match_host_distro'] = False
+        vars_['taskotron_match_host_release'] = False
+        vars_['varsfile'] = 'task_vars.json'
+
+        # load all allowed vars from tests.yml
         with open(os.path.join(self.arg_data['taskdir'], test_playbook), 'r') \
         as playbook_file:
             playbook_yaml = yaml.safe_load(playbook_file.read())
             # we only consider variables in the first play
             playbook_vars = playbook_yaml[0].get('vars', {})
         for var, val in playbook_vars.items():
-            if var.startswith('taskotron_'):
+            if var in self.ACCEPTED_VARS:
                 vars_[var] = val
 
-        # populate vars
+        # compute vars
+        vars_['artifacts'] = os.path.join(self.arg_data['artifactsdir'],
+            test_playbook)
+        vars_['artifacts_root'] = self.arg_data['artifactsdir']
+        vars_['client_taskdir'] = cfg.client_taskdir
+        vars_['heartbeat_file'] = os.path.join(vars_['artifacts_root'],
+            'taskotron', 'heartbeat.log')
+        vars_['local'] = not self.run_remotely
+        vars_['minion_repos'] = cfg.minion_repos
+        vars_['taskdir'] = self.arg_data['taskdir']
         vars_['taskotron_arch'] = self.arg_data['arch']
         vars_['taskotron_item'] = self.arg_data['item']
         vars_['taskotron_item_type'] = self.arg_data['type']
         vars_['taskotron_supported_arches'] = cfg.supported_arches
         vars_['taskotron_supported_binary_arches'] = [binarch for arch in
             cfg.supported_arches for binarch in arch_utils.Arches.binary[arch]]
-        vars_['artifacts'] = os.path.join(self.arg_data['artifactsdir'],
-            test_playbook)
-        vars_['artifacts_root'] = self.arg_data['artifactsdir']
-        vars_['client_taskdir'] = cfg.client_taskdir
-        vars_['taskdir'] = self.arg_data['taskdir']
         vars_['test_playbook'] = test_playbook
-        vars_['minion_repos'] = cfg.minion_repos
-        vars_['local'] = not self.run_remotely
-        vars_['heartbeat_file'] = os.path.join(vars_['artifacts_root'],
-            'taskotron', 'heartbeat.log')
+
         if vars_['taskotron_generic_task']:
             vars_['exec_tasks'] = 'tasks_generic.yml'
         else:
             vars_['exec_tasks'] = 'tasks_sti.yml'
+
         if os.path.isfile(os.path.join(vars_['taskdir'], 'inventory')):
             vars_['sti_inventory'] = os.path.join(vars_['client_taskdir'],
                 'inventory')
@@ -202,7 +306,7 @@ class Executor(object):
         '''
         # save forwarded variables, so that task playbook can load them
         fwdvars = {}
-        for fwdvar in _FORWARDED_VARS:
+        for fwdvar in self.FORWARDED_VARS:
             fwdvars[fwdvar] = playbook_vars[fwdvar]
         file_utils.makedirs(os.path.join(playbook_vars['artifacts'],
             'taskotron'))
@@ -362,67 +466,3 @@ class Executor(object):
             log.info('All playbooks finished successfully')
 
         return not failed
-
-
-#: list of all vars and their defaults used exposed in our runner playbook
-_PLAYBOOK_VARS_TEMPLATE = {
-    # path to the root artifacts directory (on overlord and minion)
-    'artifacts_root': None,
-    # path to the playbook-specific artifacts directory (on overlord and
-    # minion)
-    'artifacts': None,
-    # path to directory with test suite (on minion)
-    'client_taskdir': None,
-    # path to taskotron tasks playbook (generic or STI)
-    'exec_tasks': None,
-    # heartbeat will appear in this file
-    'heartbeat_file': None,
-    # add line to heartbeat_file every x seconds (2 minutes)
-    'heartbeat_interval': 120,
-    # running on local machine (overlord), no remote connection
-    'local': False,
-    # a list of repos (strings) to install on the minion
-    'minion_repos': [],
-    # path to inventory file to be used with STI tests (local inside
-    # client_taskdir or global)
-    'sti_inventory': None,
-    # path to directory with test suite (on overlord)
-    'taskdir': None,
-    # architecture of taskotron_item to be tested
-    'taskotron_arch': None,
-    # whether to run a generic or STI task
-    'taskotron_generic_task': False,
-    # item under test
-    'taskotron_item_type': None,
-    # item type under test
-    'taskotron_item': None,
-    # how long should heartbeat process run (0 to disable)
-    'taskotron_keepalive_minutes': 0,
-    # whether VM guest arch has to match taskotron_arch
-    'taskotron_match_host_arch': False,
-    # whether VM guest distro has to match taskotron_item
-    'taskotron_match_host_distro': False,
-    # whether VM guest release has to match taskotron_item
-    'taskotron_match_host_release': False,
-    # list of base architectures supported by Taskotron (e.g. 'armhfp')
-    'taskotron_supported_arches': None,
-    # list of base+binary architectures supported by Taskotron (e.g. 'armhfp,
-    # armv7hl')
-    'taskotron_supported_binary_arches': None,
-    # path to playbook to execute inside client_taskdir (usually tests.yml)
-    'test_playbook': None,
-    # name of the ansible vars file inside artifacts/taskotron/ to forward to
-    # task
-    'varsfile': 'task_vars.json',
-}
-
-#: list of all vars to be exposed in the task playbook
-# if you adjust this, also adjust html documentation
-_FORWARDED_VARS = [
-    'artifacts',
-    'taskotron_arch',
-    'taskotron_item_type',
-    'taskotron_item',
-    'taskotron_supported_arches',
-    'taskotron_supported_binary_arches',
-]

